diff --git a/doc/nft.xml b/doc/nft.xml
index 47e106900d35..661f632efefe 100644
--- a/doc/nft.xml
+++ b/doc/nft.xml
@@ -2738,8 +2738,8 @@ filter output icmpv6 type { echo-request, echo-reply }
 						<arg>skgid</arg>
 						<arg>nftrace</arg>
 						<arg>rtclassid</arg>
-						<arg>ibridgename</arg>
-						<arg>obridgename</arg>
+						<arg>ibrname</arg>
+						<arg>obrname</arg>
 						<arg>pkttype</arg>
 						<arg>cpu</arg>
 						<arg>iifgroup</arg>
@@ -2853,12 +2853,12 @@ filter output icmpv6 type { echo-request, echo-reply }
 								<entry>realm</entry>
 							</row>
 							<row>
-								<entry>ibridgename</entry>
+								<entry>ibrname</entry>
 								<entry>Input bridge interface name</entry>
 								<entry>ifname</entry>
 							</row>
 							<row>
-								<entry>obridgename</entry>
+								<entry>obrname</entry>
 								<entry>Output bridge interface name</entry>
 								<entry>ifname</entry>
 							</row>
diff --git a/src/meta.c b/src/meta.c
index f80109641757..3012efa94e24 100644
--- a/src/meta.c
+++ b/src/meta.c
@@ -413,10 +413,10 @@ static const struct meta_template meta_templates[] = {
 						1    , BYTEORDER_HOST_ENDIAN),
 	[NFT_META_RTCLASSID]	= META_TEMPLATE("rtclassid", &realm_type,
 						4 * 8, BYTEORDER_HOST_ENDIAN),
-	[NFT_META_BRI_IIFNAME]	= META_TEMPLATE("ibridgename",  &ifname_type,
+	[NFT_META_BRI_IIFNAME]	= META_TEMPLATE("ibrname",  &ifname_type,
 						IFNAMSIZ * BITS_PER_BYTE,
 						BYTEORDER_HOST_ENDIAN),
-	[NFT_META_BRI_OIFNAME]	= META_TEMPLATE("obridgename",  &ifname_type,
+	[NFT_META_BRI_OIFNAME]	= META_TEMPLATE("obrname",  &ifname_type,
 						IFNAMSIZ * BITS_PER_BYTE,
 						BYTEORDER_HOST_ENDIAN),
 	[NFT_META_PKTTYPE]	= META_TEMPLATE("pkttype",   &pkttype_type,
diff --git a/src/parser_bison.y b/src/parser_bison.y
index 54304bd34f74..f546b9edd42e 100644
--- a/src/parser_bison.y
+++ b/src/parser_bison.y
@@ -394,8 +394,8 @@ int nft_lex(void *, void *, void *);
 %token RTCLASSID		"rtclassid"
 %token IBRIPORT			"ibriport"
 %token OBRIPORT			"obriport"
-%token IBRIDGENAME		"ibridgename"
-%token OBRIDGENAME		"obridgename"
+%token IBRIDGENAME		"ibrname"
+%token OBRIDGENAME		"obrname"
 %token PKTTYPE			"pkttype"
 %token CPU			"cpu"
 %token IIFGROUP			"iifgroup"
diff --git a/src/scanner.l b/src/scanner.l
index 9e8fe00bdc3b..5f21bfd7e5e1 100644
--- a/src/scanner.l
+++ b/src/scanner.l
@@ -486,9 +486,9 @@ addrstring	({macaddr}|{ip4addr}|{ip6addr})
 "nftrace"		{ return NFTRACE; }
 "rtclassid"		{ return RTCLASSID; }
 "ibriport"		{ return IBRIPORT; }
-"ibridgename"		{ return IBRIDGENAME; }
+"ibrname"		{ return IBRIDGENAME; }
 "obriport"		{ return OBRIPORT; }
-"obridgename"		{ return OBRIDGENAME; }
+"obrname"		{ return OBRIDGENAME; }
 "pkttype"		{ return PKTTYPE; }
 "cpu"			{ return CPU; }
 "iifgroup"		{ return IIFGROUP; }
diff --git a/tests/py/bridge/meta.t b/tests/py/bridge/meta.t
index ed373677a442..f8710b25f0a7 100644
--- a/tests/py/bridge/meta.t
+++ b/tests/py/bridge/meta.t
@@ -2,5 +2,5 @@
 
 *bridge;test-bridge;input
 
-meta obridgename "br0";ok;meta obridgename "br0"
-meta ibridgename "br0";ok;meta ibridgename "br0"
+meta obrname "br0";ok;meta obrname "br0"
+meta ibrname "br0";ok;meta ibrname "br0"
diff --git a/tests/py/bridge/meta.t.payload b/tests/py/bridge/meta.t.payload
index 2728c0a5026d..0f0d101781c1 100644
--- a/tests/py/bridge/meta.t.payload
+++ b/tests/py/bridge/meta.t.payload
@@ -1,9 +1,9 @@
-# meta obridgename "br0"
+# meta obrname "br0"
 bridge test-bridge input
   [ meta load bri_oifname => reg 1 ]
   [ cmp eq reg 1 0x00307262 0x00000000 0x00000000 0x00000000 ]
 
-# meta ibridgename "br0"
+# meta ibrname "br0"
 bridge test-bridge input
   [ meta load bri_iifname => reg 1 ]
   [ cmp eq reg 1 0x00307262 0x00000000 0x00000000 0x00000000 ]
diff --git a/tests/py/inet/meta.t b/tests/py/inet/meta.t
index cfde9f32babe..644a96fdf185 100644
--- a/tests/py/inet/meta.t
+++ b/tests/py/inet/meta.t
@@ -14,5 +14,5 @@ meta nfproto ipv6 meta l4proto tcp;ok;meta nfproto ipv6 meta l4proto 6
 meta nfproto ipv4 counter ip saddr 1.2.3.4;ok
 meta secpath exists;ok
 meta secpath missing;ok
-meta ibridgename "br0";fail
-meta obridgename "br0";fail
+meta ibrname "br0";fail
+meta obrname "br0";fail
diff --git a/tests/py/ip/meta.t b/tests/py/ip/meta.t
index c3afae79314c..4db88354463e 100644
--- a/tests/py/ip/meta.t
+++ b/tests/py/ip/meta.t
@@ -8,5 +8,5 @@ meta l4proto ipv6-icmp icmpv6 type nd-router-advert;ok;icmpv6 type nd-router-adv
 meta l4proto 58 icmpv6 type nd-router-advert;ok;icmpv6 type nd-router-advert
 icmpv6 type nd-router-advert;ok
 
-meta ibridgename "br0";fail
-meta obridgename "br0";fail
+meta ibrname "br0";fail
+meta obrname "br0";fail